local function noncustomdeathchars(p)
	if p.mo.skin ~= "soapthehedge"
	and p.mo.skin ~= "takisthefox"
	and p.mo.skin ~= "adventuresonic"
	and p.mo.skin ~= "mario"
	and p.mo.skin ~= "luigi"
	and p.mo.skin ~= "prpeppino"
		return true
	else
		return false
	end
end

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and not (damagetype & DMG_INSTAKILL)
	and not (damagetype & DMG_DEATHPIT)
	and not (damagetype & DMG_CRUSHED)
		target.state = S_PLAY_PAIN
		target.flags = $ & ~MF_NOGRAVITY
		P_SetObjectMomZ(target, 4*FRACUNIT)
	end
end)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and (damagetype & DMG_DEATHPIT)
		target.flags = $ & ~MF_NOGRAVITY
		target.flags = $|MF_NOCLIPHEIGHT
		P_SetObjectMomZ(target, -40*FRACUNIT)
		target.state = S_PLAY_PAIN
	end
end)

freeslot("S_PLAY_DEADLAND","SPR2_OOF_","S_PLAY_DEADLANDALT","SPR2_SHIT","S_PLAY_DEADLANDDEFAULT")

spr2defaults[SPR2_OOF_] = SPR2_SHIT
spr2defaults[SPR2_SHIT] = SPR2_PAIN

states[S_PLAY_DEADLAND] = {
	sprite = SPR_PLAY,
	frame = SPR2_OOF_,
	tics = 2,
	nextstate = S_PLAY_DEADLAND
}

states[S_PLAY_DEADLANDALT] = {
	sprite = SPR_PLAY,
	frame = SPR2_SHIT,
	tics = 2,
	nextstate = S_PLAY_DEADLANDALT
}

states[S_PLAY_DEADLANDDEFAULT] = {
	sprite = SPR_PLAY,
	frame = SPR2_PAIN,
	tics = 2,
	nextstate = S_PLAY_DEADLANDDEFAULT
}


local function dostates(p)
	if P_IsValidSprite2(p.mo, SPR2_OOF_)
		p.mo.state = S_PLAY_DEADLAND
	elseif P_IsValidSprite2(p.mo, SPR2_SHIT)
		p.mo.state = S_PLAY_DEADLANDALT
	elseif not P_IsValidSprite2(p.mo, SPR2_OOF_)
	and not P_IsValidSprite2(p.mo, SPR2_SHIT)
		p.mo.state = S_PLAY_DEADLANDDEFAULT
	end
end

addHook("PlayerThink", function(p)
	if p.playerstate == PST_LIVE
		p.prevrollangle = p.mo.rollangle
	end
end)

addHook("ThinkFrame", do
	for p in players.iterate
		if noncustomdeathchars(p)
		and p.playerstate == PST_DEAD
		and not P_CheckDeathPitCollide(p.mo,true)
			p.mo.flags = $ & ~MF_NOCLIPHEIGHT
			p.mo.flags = $ & ~MF_NOGRAVITY
			p.mo.flags2 = $ & ~MF2_DONTDRAW
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and (p.mo.state == S_PLAY_PAIN or p.mo.state == S_PLAY_DEAD)
		and P_IsObjectOnGround(p.mo)
		and not P_CheckDeathPitCollide(p.mo,true)
			dostates(p)
			p.mo.rollangle = p.prevrollangle
			S_StartSound(p.mo, sfx_s3k5d)
			P_InstaThrust(p.mo,p.drawangle,0*FRACUNIT)
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and P_CheckDeathPitCollide(p.mo, true)
			p.mo.flags = $|MF_NOCLIPHEIGHT
			P_SetObjectMomZ(p.mo, -40*FRACUNIT)
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and not P_IsObjectOnGround(p.mo)
			p.deadtimer = 0*TICRATE
		end
	end
end)

addHook("ThinkFrame", do
	for p in players.iterate
		if p.thrustplayer == nil
			p.thrustplayer = false
		end
		if noncustomdeathchars(p)
		and p.playerstate == PST_DEAD
		and p.mo and p.mo.valid
		and not p.thrustplayer
		and not P_CheckDeathPitCollide(p.mo, true)
			P_InstaThrust(p.mo, p.drawangle, -40*FRACUNIT)
			p.mo.state = S_PLAY_PAIN
			p.thrustplayer = true
		end
		if p.playerstate == PST_LIVE
			p.thrustplayer = false
		end
		if P_CheckDeathPitCollide(p.mo, true)
			p.mo.state = S_PLAY_PAIN
			P_SetObjectMomZ(p.mo, -40*FRACUNIT)
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.rerollangle == nil
		p.rerollangle = 0
	end
	if noncustomdeathchars(p)
	and p.mo.state == S_PLAY_PAIN
	and p.playerstate == PST_DEAD
	and not P_CheckDeathPitCollide(p.mo, true)
		p.mo.rollangle = p.rerollangle
		p.rerollangle = $+ANG10
	end
end)